image: ubuntu:20.04

stages:
  - build
  - test

before_script:
  - INSTALL_PATH=/opt
  - PROJECT_PATH=$(pwd)

  - apt update
  # installed separatly otherwise ask for user interaction
  - DEBIAN_FRONTEND=noninteractive apt install -y --no-install-recommends tzdata
  # install required packages
  - apt install -y git wget cmake zip python3.8 python3-pip libpython3.8-dev libboost-dev libboost-system-dev libzip-dev libxml2-dev libpugixml-dev
  - update-alternatives --install /usr/bin/python3 python3 /usr/bin/python3.8 0
  - pip install --requirement requirements.txt

build_base:
  stage: build
  script:
    - mkdir build && cd build
    - cmake ..
    - make

test_example_1:
  stage: test
  script:
    # install simgrid
    - cd $INSTALL_PATH
    - git clone https://framagit.org/simgrid/simgrid.git
    - cd simgrid
    - mkdir build && cd build
    - cmake -Denable_smpi=OFF ..
    - make install -j$(nproc)

    # install FMI4cpp
    - cd $INSTALL_PATH
    - git clone https://github.com/NTNU-IHB/FMI4cpp.git
    - cd FMI4cpp
    - mkdir build && cd build
    - cmake ..
    - make install -j$(nproc)
    - ldconfig

    # install simgrid-FMI
    - cd $INSTALL_PATH
    - git clone https://framagit.org/simgrid/simgrid-FMI.git
    - cd simgrid-FMI
    - mkdir build && cd build
    - cmake ..
    - make install -j$(nproc)
  
    # build examples
    - cd $PROJECT_PATH
    - mkdir build && cd build
    - cmake -Dbuild_examples=ON ..
    - make

    # build fmus used by the examples 
    # using the makeFMU.py tool 
    - cd $PROJECT_PATH
    - ./build_examples_fmus.sh

    # Run example 1
    - cd $PROJECT_PATH
    - cd examples/cigre_network/binaries
    - ./cigre_network PV_ON

test_example_2:
  stage: test
  script: 
    # install simgrid
    - cd $INSTALL_PATH
    - git clone https://framagit.org/simgrid/simgrid.git
    - cd simgrid
    - mkdir build && cd build
    - cmake -Denable_smpi=OFF ..
    - make install -j$(nproc)

    # install FMI4cpp
    - cd $INSTALL_PATH
    - git clone https://github.com/NTNU-IHB/FMI4cpp.git
    - cd FMI4cpp
    - mkdir build && cd build
    - cmake ..
    - make install -j$(nproc)
    - ldconfig

    # install simgrid-FMI
    - cd $INSTALL_PATH
    - git clone https://framagit.org/simgrid/simgrid-FMI.git
    - cd simgrid-FMI
    - mkdir build && cd build
    - cmake ..
    - make install -j$(nproc)
  
    # build examples
    - cd $PROJECT_PATH
    - mkdir build && cd build
    - cmake -Dbuild_examples=ON ..
    - make

    # build fmus used by the examples 
    # using the makeFMU.py tool 
    - cd $PROJECT_PATH
    - ./build_examples_fmus.sh

    # Run example 2
    - cd $PROJECT_PATH
    - cd examples/minimal_example/binaries
    - ./minimal_example



